package missing;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.util.Map;

import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import bibliothek.gui.Dockable;
import bibliothek.gui.dock.DefaultDockable;
import bibliothek.gui.dock.DockFactory;
import bibliothek.gui.dock.layout.DockLayoutInfo;
import bibliothek.util.xml.XElement;

public class TestDockable extends DefaultDockable{
    public static final String FACTORY_ID = "test.id";
    
    public static final DockFactory<TestDockable, String> FACTORY = new DockFactory<TestDockable, String>(){
        public void estimateLocations( String layout, Map<Integer, DockLayoutInfo> children ) {
            // don't have any children...
        }

        public TestDockable layout( String layout, Map<Integer, Dockable> children ) {
            // never create dockables
            return null;
        }

        public TestDockable layout( String layout ) {
            // never create dockables
            return null;
        }

        public String getID() {
            return FACTORY_ID;
        }

        public String getLayout( TestDockable element, Map<Dockable, Integer> children ) {
            return element.getText();
        }

        public String read( DataInputStream in ) throws IOException {
            return in.readUTF();
        }

        public String read( XElement element ) {
            return element.getString();
        }

        public void setLayout( TestDockable element, String layout, Map<Integer, Dockable> children ) {
            element.setText( layout );
        }

        public void setLayout( TestDockable element, String layout ) {
            element.setText( layout );
        }

        public void write( String layout, DataOutputStream out ) throws IOException {
            out.writeUTF( layout );
        }

        public void write( String layout, XElement element ) {
            element.setString( layout );
        }
    };
    
    private JTextArea area;
    
    public TestDockable( String id ){
        super( id );
        area = new JTextArea();
        area.setText( "Dockable with id '" + id + "'" );
        add( new JScrollPane( area ) );
        setFactoryID( FACTORY_ID );
    }
    
    public String getText(){
        return area.getText();
    }
    
    public void setText( String text ){
        area.setText( text );
    }
}
